// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Terms Test 1
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;

/**
 * Question 3. Defining a method with parameters.   [8 marks]
 * 
 * This class has two methods. The drawThings() method calls the drawThing(...) method to
 * draw two [things] in different places.
 * 
 * (a) Complete the drawThing(...) method to draw a [thing] by drawing a circle and a
 * coloured rectangle. You will need to define five parameters: the position in (x,y)
 * co-ordinates, the diameter of the circle, and the length and colour of the rectangle.
 * 
 *   - The top of the circle is at the specified position
 *   - The circle is drawn with the specified diameter
 *   - The rectangle is drawn immediately below the circle, in the specified colour.
 *   - The rectangle has the specified length, and its width is the same as the diameter
 *     of the circle.
 * 
 * (b) Complete the drawThings() method to draw two [things] by calling drawThing(...)
 * twice using different arguments. Your method should draw the [things] shown in the
 * test handout. The larger [thing] is red, and the smaller [thing] is blue.
 */
public class Program3 {
    
    /**
     * Draws a thing by drawing a circle and a coloured rectangle [6 marks]
     */
    public void drawThing( double x, double y, double diameter, double length, Color color ) {
        // The circle should be drawn in black
        UI.setColor(Color.BLACK);
        /*# YOUR CODE HERE */
        // Draw the circle
        UI.drawOval(x-diameter/2,y,diameter,diameter);
        // Draw the rectangle
        UI.setColor(color);
        UI.fillRect(x-diameter/2,y+diameter,diameter,length);
        /*# END OF YOUR CODE */
    }

    /**
     * Draws things by drawing two things on the screen. [2 marks]
     */
    public void drawThings() {
        UI.clearGraphics();
        this.drawThing( 100,  50, 100, 150, Color.RED );
        this.drawThing( 350, 200,  50, 100, Color.BLUE );
    } 

    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Run", this::drawThings);
        UI.setWindowSize(500,500);
        UI.setDivider(0.0);
    }
    
    public static void main(String[] args) {
        new Program3().setupGUI();
    }
}
